package blackout;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.junit.jupiter.api.Assertions.assertNotEquals;

import java.util.List;

import org.junit.jupiter.api.Test;

import unsw.blackout.BlackoutController;
import unsw.response.models.EntityInfoResponse;
import unsw.utils.Angle;
import unsw.utils.MathsHelper;

public class Task3ExampleTests {
    @Test
    public void testCreatingAMovingDevice() {
        BlackoutController controller = new BlackoutController();

        controller.createDevice("Device1", "HandheldDevice", Angle.fromDegrees(180), true);
        assertEquals(controller.listDeviceIds(), List.of("Device1"));

        assertEquals(controller.getInfo("Device1"), new EntityInfoResponse("Device1", Angle.fromDegrees(180),
                MathsHelper.RADIUS_OF_JUPITER, "HandheldDevice"));
        controller.simulate(5);

        assertNotEquals(controller.getInfo("Device1").getPosition(), Angle.fromDegrees(180));
    }

    @Test
    public void testCreatingAnElephantSatellite() {
        BlackoutController controller = new BlackoutController();

        controller.createSatellite("Satellite1", "ElephantSatellite", 100 + MathsHelper.RADIUS_OF_JUPITER,
                Angle.fromRadians(0));
        assertEquals(controller.listSatelliteIds(), List.of("Satellite1"));

        assertEquals(controller.getInfo("Satellite1"), new EntityInfoResponse("Satellite1", Angle.fromRadians(0),
                100 + MathsHelper.RADIUS_OF_JUPITER, "ElephantSatellite"));
    }
}
